<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<form
  [formGroup]="extSigForm"
  class="ls-form">

  <div class="modal-header">
    <h4
      class="modal-title overflow-hidden text-overflow-ellipsis text-nowrap"
      id="modal-basic-title"
      [innerText]="messages.getConnectorEditOrCreatePopupTitle(editMode, currentConfig?.name)">
    </h4>
    <button
      type="button"
      class="btn-close"
      [title]="commonMessages.CLOSE"
      (click)="cancel()">
    </button>
  </div>

  <div class="modal-body mt-4 mx-3">

    <div class="form-group required">
      <label
        for="nameInput"
        [innerText]="commonMessages.NAME">
      </label>
      <input
        id="nameInput"
        name="nameInput"
        type="text"
        class="form-control"
        formControlName="name">
    </div>

    <div class="form-group required">
      <label
        for="urlInput"
        [innerText]="messages.URL">
      </label>
      <input
        id="urlInput"
        name="urlInput"
        type="text"
        class="form-control"
        formControlName="url">
    </div>

    <div class="form-group">
      <label
        for="serviceSelect"
        [innerText]="messages.SERVICE">
      </label>
      <ng-select
        id="serviceSelect"
        formControlName="serviceName"
        [clearable]="false"
        [inputAttrs]="{ name: 'provider' }"
        (change)="onServiceChange()">

        <ng-option
          *ngFor="let service of availableServices"
          [value]="service"
          [innerText]="service | externalSignatureProvider">
        </ng-option>
      </ng-select>
    </div>

    <div
      *ngIf="showSignatureLevelField"
      class="form-group">
      <label
        for="signatureLevelSelect"
        [innerText]="messages.SIGNATURE_LEVEL">
      </label>
      <ng-select
        [clearable]="false"
        (change)="onServiceChange()"
        id="signatureLevelSelect"
        formControlName="signatureLevel">

        <ng-option
          *ngFor="let signatureLevel of availableSignatureLevels"
          [value]="signatureLevel"
          [innerText]="signatureLevel | externalSignatureLevel">
        </ng-option>
      </ng-select>
    </div>

    <div
      *ngIf="showTokenField"
      class="form-group required">
      <label
        for="tokenInput"
        [innerText]="messages.TOKEN">
      </label>
      <input
        id="tokenInput"
        name="tokenInput"
        type="text"
        class="form-control"
        formControlName="token"
        [placeholder]="editMode ? messages.TOKEN_EDIT_PLACEHOLDER : ''">
    </div>

    <div
      *ngIf="showLoginField"
      class="form-group required">
      <label
        for="loginInput"
        [innerText]="messages.LOGIN">
      </label>
      <input
        id="loginInput"
        name="loginInput"
        type="text"
        class="form-control"
        required
        formControlName="login">
    </div>

    <div
      *ngIf="showPasswordField"
      class="form-group required">
      <label
        for="passwordInput"
        [innerText]="commonMessages.PASSWORD">
      </label>
      <div class="input-group">

        <input
          id="passwordInput"
          name="passwordInput"
          class="form-control"
          formControlName="password"
          [placeholder]="editMode ? messages.PASSWORD_EDIT_PLACEHOLDER : ''"
          [type]="hidePassword ? 'password' : 'text'">

        <div
          class="input-group-text pointer"
          (click)="hidePassword = !hidePassword">
          <fa-icon
            class="hide-password-button text-center"
            [icon]="hidePassword ? eyeIcon : eyeSlashIcon"
            [fixedWidth]="true">
          </fa-icon>
        </div>
      </div>

    </div>

  </div>

  <div class="modal-footer">
    <button
      ls-button-cancel
      (click)="cancel()">
    </button>
    <button
      ls-button
      [processing]="isProcessing"
      (click)="executeForm()"
      [text]="editMode ? commonMessages.EDIT : commonMessages.ADD"
      [icon]="editMode ? commonIcons.EDIT_ICON : commonIcons.ADD_ICON"
      [disabled]="!extSigForm.valid">
    </button>
  </div>

</form>
